//+------------------------------------------------------------------+
//|                                                    TrendLabs.mq4 |
//|                               Copyright  2008, NonDisclosure007 |
//|                                         http://www.nolinkyet.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, NonDisclosure007"
#property link      "http://www.metaquotes.net"




#property indicator_separate_window
#property indicator_buffers  1
#property indicator_color1  Goldenrod
#property indicator_width1  3
#property indicator_level1  3
#property indicator_level2 -3
#property indicator_level3  0
#property indicator_levelstyle STYLE_DOT
#property indicator_levelcolor Magenta
#property indicator_minimum -4
#property indicator_maximum 4




extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert.wav";
extern int    highlevel       = 3;
extern int    lowlevel        = -3;




double Buffer[];
double trend[];






int init()
  {
   IndicatorBuffers(2);
   SetIndexBuffer(0,Buffer);
   SetIndexBuffer(1,trend);
   
   return(0);
  }

int deinit(){ return(0);}




int start()
  {
  int counted_bars=IndicatorCounted();
   int i,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
        limit=MathMin(Bars-counted_bars,Bars-1);
  
  
  
  
  
  
  
  
  
      for(i=limit; i >= 0; i--)
      {
      Buffer[i] =
      funcGetAbsoluteStrength(i)+
      iCustom(NULL,0,"LabTrend1",3,1,1,0,6,i)+
      iCustom(NULL,0,"LabTrend2",3,2,9,50,0,0,4,i)+
      iCustom(NULL,0,"LabTrend3",3,2,9,7,i)+
      iRSI(NULL,0,14,0,i)/100;
   
      if (Buffer[i] > highlevel && Buffer[i+1] <= highlevel) trend[i] = 1;   
      if (Buffer[i] <  lowlevel && Buffer[i+1] >= lowlevel)  trend[i] = -1; 
      }
      if (alertsOn)
      {
      if (alertsOnCurrent)
      int whichBar = 0;
      else     whichBar = 1;

         //
         //
         //
         //
         //
         
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("uptrend");
         else  doAlert("downtrend");       
   }
   
   return(0);
}
//+------------------------------------------------------------------+


void doAlert(string doWhat)
{
   static string   previousAlert=" nothing ";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," TrendLabs ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," TrendLabs "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}  

double funcGetAbsoluteStrength(int Current)
{
      double Bulls    = iCustom(NULL,0,"AbsoluteStrengthForEA",0,Current);
      double Bears    = iCustom(NULL,0,"AbsoluteStrengthForEA",1,Current);

   
   if (Bulls == 1) return(1);
   if (Bears == 2) return(-1);
   return(0);
}